#!C:/Program Files/AutoIt3/AutoIt3.exe /ErrorStdOut

#NoTrayIcon
#include <Web.au3>
#include <String.au3>
#include <File.au3>
#Include <Date.au3>
#Include <_Base64.au3>
Global $Parent_Directory
Global $HTDIR
Global $RootDir = $_DOCUMENT_ROOT ; Default value (Recommended)
Global $Settings = $_DOCUMENT_ROOT & '\dirlist\DL-Config.ini'
Global $DefaultIcon = '/dirlist/img/preview.gif'
Global $Mask = '*'
Global $DIRQuery = 'dir'
Global $TransferQuery = 'trn'
Global $LoginUserPost = 'login'
Global $UserLogout = 'logout'
Global $LoginPasswordPost = 'password'
Global $Encoding = 'utf-8'
Global $ScriptVersion = '1.9 RC1' ; &beta;
Global $Interpreter_Version = FileGetVersion(@AutoItExe)
Global $AnonymousName = 'Anonymous'
Global $LoggedUser = _User(_GetCookie ('uid'))

Func _Reserved($Encoded)
	Local $strHex = "", $iDec
	Local $aryChar = StringSplit($Encoded, "")
	For $i = 1 To $aryChar[0]
		If StringInStr("$&+,:;=?@", $aryChar[$i]) Then  ; Removed "/" from list for URI compatibility.
			$strHex = $strHex & "%" & Hex(Asc($aryChar[$i]), 2)
		Else
			$strHex = $strHex & $aryChar[$i]
		EndIf
	Next
	Return $strHex
EndFunc   ;==>_Reserved

Func _Input($File)
	If StringInStr(FileGetAttrib($RootDir & '\' & $File), 'D') Then
		$HTDIR = IniRead($RootDir & $File & '\.htdir', 'Folder', 'Access', 0)
		If $HTDIR = 2 And $LoggedUser = $AnonymousName Or $HTDIR = 3 And $LoggedUser = $AnonymousName Then
			$BEMsg = '<b>Access Forbidden</b><br />You do not have permission to access: "' & _UnicodeStringConvert($DIR) & '".'
			_ErrorMsg($BEMsg, 1)
		Else
			_Output($File & '/')
		EndIf
	ElseIf FileExists($RootDir & '/' & $File) < 1 Then
		$BEMsg = '<b>File Not Found</b><br />The requested: "' & _UnicodeStringConvert($DIR) & '" was not found on this server.'
		_ErrorMsg($BEMsg)
	Else
		_DebugMsg()
	EndIf
EndFunc   ;==>_Input

Func _GetCookie($sVar)
   ; Local $varstring, $num, $vars, $var_array
   ; $varstring = $_Cookie_Raw
   ; If Not StringInStr($varstring, $sVar&"=") Then Return ""
  ;  $num = __StringFindOccurances($varstring, "=")
  ;  Local $vars[$num+1]
  ; $vars = StringSplit ($varstring, ";")
  ;  For $i=1 To $vars[0]
  ;      $var_array = StringSplit ($vars[$i], "=")
  ;      If $var_array[0] < 2 Then Return "error"
  ;      If $var_array[1] = $sVar Then Return $var_array[2]
  ;  Next
   ; Return ""
   
   $var = $_Cookie_Raw
   If StringInStr($var, $sVar&"=") Then
	
	$vars = StringSplit ($var, ";")
	For $i=1 To $vars[0]
	;If $var_array[0] < 1 Then Return ""
	;If $var_array[0] < 2 Then Return "error"
	$var_array = $vars[$i]
	If StringInStr($var_array,$sVar&"=") Then Return StringReplace($var_array,$sVar&"=","",1)
	Next
	Return ""
Else
	Return ""
	EndIf
   
EndFunc


Func _DebugMsg()
	Local $BEMsg
	$BEMsg &= '<i>#Unexpected error occurred at: ' & _NowDate() & ' - ' & _NowTime() & '<br />#Debug Informations:<br /><br /></i>'
	$BEMsg &= '<b>[Client Informations]</b> <br />'
	$BEMsg &= 'Remote Address: ' & $_REMOTE_ADDR & '<br />'
	$BEMsg &= 'Connected Port: ' & $_REMOTE_PORT & '<br />'
	$BEMsg &= 'Request Method: ' & $_REQUEST_METHOD & '<br />'
	$BEMsg &= 'Request URI: ' & $_REQUEST_URI & '<br />'
	$BEMsg &= 'User-Agent: ' & $_USER_AGENT & '<br /><br />'
	$BEMsg &= '<b>[Server Informations]</b> <br />'
	$BEMsg &= 'Server Name: ' & $_SERVER_NAME & '<br />'
	$BEMsg &= 'Listen Port: ' & $_SERVER_PORT & '<br /><br />'
	$BEMsg &= '<b>[Script Informations]</b> <br />'
	$BEMsg &= 'Interperter: AutoIt v' & $Interpreter_Version & '<br />'
	$BEMsg &= 'Processed Request:' & '<br />'
	$BEMsg &= '- $DIR = ' & _UnicodeStringConvert($DIR) & '<br />'
	_ErrorMsg($BEMsg)
EndFunc   ;==>_DebugMsg

Func _WMsg($WMsgTitle = '', $WMsgBody = '')
	Local $HTML
	$HTML &= '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">' & @CRLF
	$HTML &= '<html xml:lang="en" lang="en" xmlns="http://www.w3.org/1999/xhtml">' & @CRLF
	$HTML &= '<head>' & @CRLF
	$HTML &= '<meta http-equiv="content-type" content="text/html; charset=' & $Encoding & '" />' & @CRLF
	$HTML &= '<title>' & $_HOST & ' -> Directory Listing</title>' & @CRLF
	$HTML &= '<link href="/dirlist/css/default.css" rel="stylesheet" type="text/css">' & @CRLF
	$HTML &= '<div id="ipbwrapper">' & @CRLF
	$HTML &= '<div id="userlinks">' & @CRLF
	;$HTML &= '<p class="home">User:  <b>'
	;$LoggedUser = _User(_GetCookie ('uid'))
	;$HTML &= $LoggedUser & '</b>@' & $_REMOTE_ADDR & '</p>''
		$HTML &= '<p class="home"><b>User:  '
	$LoggedUser = _User(_GetCookie ('uid'))
	$HTML &= $LoggedUser & '</b>@<font color="#228814">' & $_REMOTE_ADDR & '</font>'
	If $LoggedUser = $AnonymousName Then
		$HTML &= ''
	Else
		$HTML &= ' ( <a href="' & $_SCRIPT_NAME & '?logout=true&' & $DIRQuery & '=' & $DIR & '" title="Log Out">Log Out</a> )'
	EndIf
	$HTML &= '</p>'
	;;
	$HTML &= '<p>'
	$HTML &= '&nbsp;'
	$HTML &= '</p>'
	$HTML &= '</div>' & @CRLF
	$HTML &= '<div class="borderwrap">' & @CRLF
	$HTML &= '<h3>' & $WMsgTitle & '</h3>' & @CRLF
	$HTML &= '<p>' & $WMsgBody & '</p>' & @CRLF
	$HTML &= '<p class="formbuttonrow"><b><a href="javascript:history.go(-1)">Go Back</a></b></p>'
	$HTML &= '</div>'
	$HTML &= '<br />' & @CRLF
	$HTML &= '<div align="center" class="copyright">' & @CRLF
	$HTML &= 'Directory Listing v' & $ScriptVersion & ' - Written By <a href="http://dhilip89.hopto.org/" style="text-decoration:none" target="_blank">Dhilip89</a>'
	$HTML &= ' &copy; 2007&nbsp;Dhilip89. <br />Powered By: <a href="http://www.autoitscript.com/" style="text-decoration:none" target="_blank">AutoIt</a> v' & $Interpreter_Version & '</div>' & @CRLF
	$HTML &= '</div>' & @CRLF
	$HTML &= '</body>' & @CRLF
	$HTML &= '</html>'
	echo ($HTML)
EndFunc   ;==>_WMsg

Func _ErrorMsg($EMsgBody = '', $Mode = 0)
	Local $HTML
	$HTML &= '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">' & @CRLF
	$HTML &= '<html xml:lang="en" lang="en" xmlns="http://www.w3.org/1999/xhtml">' & @CRLF
	$HTML &= '<head>' & @CRLF
	$HTML &= '<meta http-equiv="content-type" content="text/html; charset=' & $Encoding & '" />' & @CRLF
	$HTML &= '<title>' & $_HOST & ' -> Directory Listing (Error Message)</title>' & @CRLF
	$HTML &= '<link href="/dirlist/css/default.css" rel="stylesheet" type="text/css">' & @CRLF
	$HTML &= '<div id="ipbwrapper">' & @CRLF
	$HTML &= '<div id="userlinks">' & @CRLF
	;$HTML &= '<p class="home">User:  <b>'
	;$LoggedUser = _User(_GetCookie ('uid'))
	;$HTML &= $LoggedUser & '</b>@' & $_REMOTE_ADDR & '</p>'
		$HTML &= '<p class="home"><b>User:  '
	$LoggedUser = _User(_GetCookie ('uid'))
	$HTML &= $LoggedUser & '</b>@<font color="#228814">' & $_REMOTE_ADDR & '</font>'
	If $LoggedUser = $AnonymousName Then
		$HTML &= ''
	Else
		$HTML &= ' ( <a href="' & $_SCRIPT_NAME & '?logout=true&' & $DIRQuery & '=' & $DIR & '" title="Log Out">Log Out</a> )'
	EndIf
	$HTML &= '</p>'
	;;
	$HTML &= '<p>'
	$HTML &= '&nbsp;'
	$HTML &= '</p>'
	$HTML &= '</div>' & @CRLF
	$HTML &= '<div class="borderwrap">' & @CRLF
	$HTML &= '<h3>' & 'Error Message' & '</h3>' & @CRLF
	$HTML &= '<p>' & " We're sorry, an error occurred while processing your request." & '</p>' & @CRLF
	$HTML &= '<div class="errorwrap">' & @CRLF
	$HTML &= '<h4>The error returned was:</h4>' & @CRLF
	$HTML &= '<p>' & $EMsgBody & '</p></div>' & @CRLF
	If $Mode = 1 Then
	$HTML &= '<form action="' & $_SCRIPT_NAME & '?' & $TransferQuery & '=' & $DIR & '" method="post">' & @CRLF
	;$HTML &= '<input name="act" value="Login" type="hidden">' & @CRLF
	;$HTML &= '<input name="CODE" value="01" type="hidden">' & @CRLF
	;$HTML &= '<input name="s" value="dfb47fac965b8805d08110fd32f0d1f8" type="hidden">' & @CRLF
	;$HTML &= '<input name="referer" value="act=Members" type="hidden">' & @CRLF
	;$HTML &= '<input name="CookieDate" value="1" type="hidden">' & @CRLF
	$HTML &= '<h4>You are not logged in, you may log in below</h4>' & @CRLF
	$HTML &= '<div class="fieldwrap">' & @CRLF
	$HTML &= '<h4>Username:</h4>' & @CRLF
	$HTML &= '<input size="20" maxlength="64" name="' & $LoginUserPost & '" type="text">' & @CRLF
	$HTML &= '<h4>Password:</h4>' & @CRLF
	$HTML &= '<input size="20" name="' & $LoginPasswordPost & '" type="password">' & @CRLF
	$HTML &= '<p class="formbuttonrow1"><input class="button" name="submit" value="Log In" type="submit"></p>' & @CRLF
	$HTML &= '</div>' & @CRLF
	$HTML &= '</form>' & @CRLF
	EndIf
	$HTML &= '<p class="formbuttonrow"><b><a href="javascript:history.go(-1)">Go Back</a></b></p>'
	$HTML &= '</div>'
	$HTML &= '</div>' & @CRLF
	$HTML &= '<div align="center" class="copyright">' & @CRLF
	$HTML &= 'Directory Listing v' & $ScriptVersion & ' - Written By <a href="http://dhilip89.hopto.org/" style="text-decoration:none" target="_blank">Dhilip89</a>'
	$HTML &= ' &copy; 2007&nbsp;Dhilip89. <br />Powered By: <a href="http://www.autoitscript.com/" style="text-decoration:none" target="_blank">AutoIt</a> v' & $Interpreter_Version & '</div>'
	$HTML &= '</div>'
	$HTML &= '</body>'
	$HTML &= '</html>'
	echo ($HTML)
EndFunc   ;==>_ErrorMsg

Func _Output($Path)
	Local $HTML
	
			;$ArrayNum_A = $ArrayNum_A + 1
		;$DIR_Split_A = $DIR
		$DIR_ArrayX = StringSplit($DIR, '/', 1)
		$ArrayNum_X = $DIR_ArrayX[0]
	 $TDName = $DIR_ArrayX[$ArrayNum_X]
	 If $TDName = '' Then $TDName = 'Root'
	
	$TDirName = _UnicodeStringConvert($TDName)
	$HTML &= '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">' & @CRLF
	$HTML &= '<html xml:lang="en" lang="en" xmlns="http://www.w3.org/1999/xhtml">' & @CRLF
	$HTML &= '<head>' & @CRLF
	$HTML &= '<meta http-equiv="content-type" content="text/html; charset=' & $Encoding & '" />' & @CRLF
	$HTML &= '<title>' & $_HOST & ' -> Directory Listing: "' & $TDirName & '"</title>' & @CRLF
	$HTML &= '<link href="/dirlist/css/default.css" rel="stylesheet" type="text/css">' & @CRLF
	$HTML &= '</head>' & @CRLF
	$HTML &= '<body>' & @CRLF
	$HTML &= '<div id="ipbwrapper">' & @CRLF
	$HTML &= '<div id="userlinks">' & @CRLF
	$HTML &= '<p class="home"><b>User:  '
	$LoggedUser = _User(_GetCookie ('uid'))
	$HTML &= $LoggedUser & '</b>@<font color="#228814">' & $_REMOTE_ADDR & '</font>'
	
	If $LoggedUser = $AnonymousName Then
		$HTML &= ''
	Else
		$HTML &= ' ( <a href="' & $_SCRIPT_NAME & '?logout=true&' & $DIRQuery & '=' & $DIR & '" title="Log Out">Log Out</a> )'
	EndIf
	
	$HTML &= '</p>'
	$HTML &= '<p>'
	$HTML &= '&nbsp;'
	$HTML &= '</p>'
	$HTML &= '</div>' & @CRLF
	$HTML &= '<div class="borderwrap">' & @CRLF
	$HTML &= '<div class="maintitle">' & @CRLF
	$HTML &= '<p>Directory Listing: <br /><img src="/dirlist/css/nav_m.gif" border="0"  alt="&gt;" width="8" height="8" />&nbsp;'
	$ArrayNum_A = 0
	$HTML &= '<a href="' & $_SCRIPT_NAME & '?' & $DIRQuery & '=' & '/' & '" title="Root">Root</a>'
	Do
		
		$ArrayNum_A = $ArrayNum_A + 1
		$DIR_Split_A = $DIR
		$DIR_Array = StringSplit($DIR_Split_A, '/', 1)
		$ArrayNum_B = $DIR_Array[0]
		$DIR_Link = ''
		For $N = 1 To $ArrayNum_A Step 1
			$DIR_Link &= $DIR_Array[$N] & '/'
		Next
		$HTML &= '<a href="' & $_SCRIPT_NAME & '?' & $DIRQuery & '=' & _Reserved(_UnicodeURLEncode($DIR_Link)) & '" title="' & _UnicodeStringConvert($DIR_Array[$ArrayNum_A]) & '">' & _UnicodeStringConvert($DIR_Array[$ArrayNum_A]) & '</a>'
		$HTML &= '/'
		;echo ($DIR_Array[$ArrayNum_A])
	Until $ArrayNum_B = $ArrayNum_A
	$HTML &= '</p>'
	$HTML &= '</div>' & @CRLF
	$HTML &= '<table class="ipbtable" cellspacing="1"><tr>' & @CRLF
	$HTML &= '<th colspan="1" width="51%">File Name</th>' & @CRLF
	$HTML &= '<th style="text-align:center;" width="9%">Size</th>' & @CRLF
	$HTML &= '<th style="text-align:center;" width="35%">Last modified</th>'
	$HTML &= '</tr>' & @CRLF
	$Count = 0
	If StringInStr($DIR, '/') < 1 Then $DIR = _StringInsert($DIR, '/', 0)
	Do
		$Check = StringRight($DIR, 1)
		If $Check = '' Then ExitLoop
		If $Check = '/' Then ExitLoop
		$Count = $Count + 1
		$Parent_Directory = StringTrimRight($DIR, $Count)
		$Check = StringRight($Parent_Directory, 1)
	Until $Check = '/'
	If $Parent_Directory = '' Then
		$Image = IniRead($Settings, 'Folder', 'HDIR', $DefaultIcon)
		$HTML &= '<td class="row2">'
		$HTML &= '<img src="'
		$HTML &= $Image
		$HTML &= '" border="0" alt="[U]" /> ' ;&#8593;
		$HTML &= '<a href="' & 'http://' & $_HOST & '" title="Parent Directory">Parent Directory (Home Page)</a></td>'
	Else
		$Image = IniRead($Settings, 'Folder', 'PDIR', $DefaultIcon)
		$HTML &= '<td class="row2">'
		$HTML &= '<img src="'
		$HTML &= $Image
		$HTML &= '" border="0" alt="[U]" /> '
		$HTML &= '<a href="' & $_SCRIPT_NAME & '?' & $DIRQuery & '=' & _Reserved(_UnicodeURLEncode($Parent_Directory)) & '" title="Parent Directory">Parent Directory</a></td>'
	EndIf
	$HTML &= '<td align="center" class="row2">'
	$HTML &= '</td>'
	$HTML &= '<td align="left" class="row2"></td></tr>' & @CRLF
	$Search = FileFindFirstFile($RootDir & $Path & $Mask)
	$FileName = FileFindNextFile($Search)
	If Not @error Then
		While Not @error
			$FullFileName = $Path & $FileName
			$Modified = FileGetTime($RootDir & $FullFileName, 0)
			$LastModified = $Modified[0] & '/' & $Modified[1] & '/' & $Modified[2] & ' ' & $Modified[3] & ':' & $Modified[4] & ':' & $Modified[5]
			$Attribute = FileGetAttrib($RootDir & $FullFileName)
			If StringInStr($Attribute, 'D') Then
				$HTDIR = IniRead($RootDir & $FullFileName & '\.htdir', 'Folder', 'Access', 0)
				If $HTDIR = 1 And $LoggedUser = $AnonymousName Then
					$FileName = FileFindNextFile($Search)
				ElseIf $HTDIR = 3 And $LoggedUser = $AnonymousName Then
					$FileName = FileFindFirstFile($Search)
					Else
					$Image = IniRead($Settings, 'Folder', 'DIR', $DefaultIcon)
					$HTML &= '<td class="row2">'
					$HTML &= '<img src="'
					$HTML &= $Image
					$HTML &= '" border="0" alt="[D]" /> '
					$HTML &= '<a href="' & $_SCRIPT_NAME & '?' & $DIRQuery & '=' & _Reserved(_UnicodeURLEncode($FullFileName)) & '" title="' & _UnicodeStringConvert($FileName) & '">' & _UnicodeStringConvert($FileName) & '</a></td>'
					$HTML &= '<td align="center" class="row2">'
					$FileSize = FileGetSize($RootDir & $FullFileName)
					$HTML &= '-'
					$HTML &= '</td>'
					$HTML &= '<td align="left" class="row2">' & _DateTimeFormat($LastModified, 1) & ' ' & _DateTimeFormat($LastModified, 3) & '</td></tr>' & @CRLF
				EndIf
			EndIf
			$FileName = FileFindNextFile($Search)
		WEnd
	EndIf
	$Search = FileFindFirstFile($RootDir & $Path & $Mask)
	$FileName = FileFindNextFile($Search)
	If Not @error Then
		While Not @error
			$FullFileName = $Path & $FileName
			$Modified = FileGetTime($RootDir & $FullFileName, 0)
			$LastModified = $Modified[0] & '/' & $Modified[1] & '/' & $Modified[2] & ' ' & $Modified[3] & ':' & $Modified[4] & ':' & $Modified[5]
			$Attribute = FileGetAttrib($RootDir & $FullFileName)
			If Not StringInStr($Attribute, 'D') Then
				$ExtMarker = StringInStr($RootDir & $FileName, '.', 0, -1)
				$Extension = StringMid($RootDir & $FileName, $ExtMarker + 1)
				$Image = IniRead($Settings, 'Extension', $Extension, $DefaultIcon)
				$HTML &= '<td class="row2">'
				$HTML &= '<img src="'
				$HTML &= $Image
				$HTML &= '" border="0" alt="[F]" /> '
				$HTML &= '<a href="' & _Reserved(_UnicodeURLEncode($FullFileName)) & '" title="' & _UnicodeStringConvert($FileName) & '">' & _UnicodeStringConvert($FileName) & '</a></td>'
				$HTML &= '<td align="center" class="row2">'
				$FileSize = FileGetSize($RootDir & $FullFileName)
				If $FileSize < 1024 Then
					$HTML &= $FileSize & ' B'
				ElseIf $FileSize >= 1024 And $FileSize < 1048576 Then
					$HTML &= Round($FileSize / 1024, 2) & ' K'
				ElseIf $FileSize >= 1048576 And $FileSize < 1073741824 Then
					$HTML &= Round($FileSize / 1024 / 1024, 2) & ' M'
				ElseIf $FileSize >= 1073741824 And $FileSize < 1099511627776 Then
					$HTML &= Round($FileSize / 1024 / 1024 / 1024, 2) & ' G'
				ElseIf $FileSize >= 1099511627776 And $FileSize < 1125899906842624 Then
					$HTML &= Round($FileSize / 1024 / 1024 / 1024 / 1024, 2) & ' T'
				ElseIf $FileSize >= 1125899906842624 And $FileSize < 1152921504606846976 Then
					$HTML &= Round($FileSize / 1024 / 1024 / 1024 / 1024 / 1024, 2) & ' P'
				ElseIf $FileSize >= 1152921504606846976 And $FileSize < 1180591620717411303424 Then
					$HTML &= Round($FileSize / 1024 / 1024 / 1024 / 1024 / 1024 / 1024, 2) & ' E'
				ElseIf $FileSize >= 1180591620717411303424 And $FileSize < 1208925819614629174706176 Then
					$HTML &= Round($FileSize / 1024 / 1024 / 1024 / 1024 / 1024 / 1024 / 1024, 2) & ' Z'
				ElseIf $FileSize >= 1208925819614629174706176 And $FileSize < 1237940039285380274899124224 Then
					$HTML &= Round($FileSize / 1024 / 1024 / 1024 / 1024 / 1024 / 1024 / 1024 / 1024, 2) & ' Y'
				EndIf
				$HTML &= '</td>'
				$HTML &= '<td align="left" class="row2">' & _DateTimeFormat($LastModified, 1) & ' ' & _DateTimeFormat($LastModified, 3) & '</td></tr>' & @CRLF
			EndIf
			$FileName = FileFindNextFile($Search)
		WEnd
	EndIf
	$HTML &= '<tr><td class="catend" colspan="8"></td>'
	$HTML &= '</tr>'
	$HTML &= '</table>'
	$HTML &= '</div>'
	$HTML &= '<br />' & @CRLF
	$HTML &= '<div align="center" class="copyright">' & @CRLF
	$HTML &= 'Directory Listing v' & $ScriptVersion & ' - Written By <a href="http://dhilip89.hopto.org/" style="text-decoration:none" target="_blank">Dhilip89</a>'
	$HTML &= ' &copy; 2007&nbsp;Dhilip89. <br />Powered By: <a href="http://www.autoitscript.com/" style="text-decoration:none" target="_blank">AutoIt</a> v' & $Interpreter_Version & '</div>'
	$HTML &= '</div>'
	$HTML &= '</body>'
	$HTML &= '</html>'
	echo ($HTML)
EndFunc   ;==>_Output

Func _UnicodeURLEncode($UnicodeURL)
	$UnicodeBinary = StringToBinary ($UnicodeURL, 4)
	$UnicodeBinary2 = StringReplace($UnicodeBinary, '0x', '', 1)
	$UnicodeBinaryLength = StringLen($UnicodeBinary2)
	Local $EncodedString
	For $i = 1 To $UnicodeBinaryLength Step 2
		$UnicodeBinaryChar = StringMid($UnicodeBinary2, $i, 2)
		If StringInStr("$-_.+!*'(),;/?:@=&abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890", BinaryToString ('0x' & $UnicodeBinaryChar, 4)) Then
			$EncodedString &= BinaryToString ('0x' & $UnicodeBinaryChar)
		Else
			$EncodedString &= '%' & $UnicodeBinaryChar
		EndIf
	Next
	Return $EncodedString
EndFunc   ;==>_UnicodeURLEncode

Func _UnicodeStringConvert($UnicodeString)
	$UnicodeStringLength = StringLen($UnicodeString)
	Local $Unicode_Code
	For $i = 1 To $UnicodeStringLength
		$UnicodeStringChar = StringMid($UnicodeString, $i, 1)
		If StringInStr(" $-_.+!*'(),;/?:@=&abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890", $UnicodeStringChar) Then
			$Unicode_Code &= $UnicodeStringChar
		Else
			$Unicode_Code &= '&#' & AscW ($UnicodeStringChar) & ';'
		EndIf
	Next
	Return $Unicode_Code
EndFunc   ;==>_UnicodeStringConvert

Func _UnicodeURLDecode_DIR($toDecode)
	Local $strChar = '', $iOne, $iTwo
	Local $aryHex = StringSplit($toDecode, '')
	For $i = 1 To $aryHex[0]
		If $aryHex[$i] = '%' Then
			$i = $i + 1
			$iOne = $aryHex[$i]
			$i = $i + 1
			$iTwo = $aryHex[$i]
			$strChar = $strChar & Chr(Dec($iOne & $iTwo))
		Else
			$strChar = $strChar & $aryHex[$i]
		EndIf
	Next
	$Process = StringToBinary ($strChar)
	$DecodedString = BinaryToString ($Process, 4)
	Return $DecodedString
EndFunc   ;==>_UnicodeURLDecode_DIR

Func _Get_DIR($sVar, $iVarType = 0)
	Local $varstring, $num, $vars, $var_array
	$varstring = $_GET_raw
	If Not StringInStr($varstring, $sVar & "=") Then Return ""
	$num = __StringFindOccurances ($varstring, "=")
	Local $vars[$num + 1]
	$vars = StringSplit($varstring, "&")
	For $i = 1 To $vars[0]
		If $iVarType Then
			If $vars[$i] = $sVar Then Return True
		Else
			$var_array = StringSplit($vars[$i], "=")
			If $var_array[0] < 2 Then Return "error"
			If $var_array[1] = $sVar Then Return _UnicodeURLDecode_DIR($var_array[2])
		EndIf
	Next
	If $iVarType Then Return False
	Return True
EndFunc   ;==>_Get_DIR

Func _Authenticate($Username, $Password = '') ;1 = set, 0 = dec
	If $Username <> '' Then
		$UsrPassW = IniRead($_DOCUMENT_ROOT & '\dirlist\.htduser', $Username, 'Password', -1)
		If $UsrPassW = $Password Then
			$Encrypted = _Base64Encode($Username & '::[' & $Password & ']::') ; _StringEncrypt(1, $Username & '::[' & $Password & ']::', 'DLS19')
			$Cookie = 'uid=' & $Encrypted
			ConsoleWrite('Set-Cookie: ' & $Cookie & Chr(13) & Chr(10))
			ConsoleWrite(Chr(13) & Chr(10))
		Else
			ConsoleWrite(Chr(13) & Chr(10))
		EndIf
	ElseIf _Get_DIR($UserLogout) = 'true' Then
	_Logout()
Else
	ConsoleWrite(Chr(13) & Chr(10))
;EndIf
		;;;;;;;;;;;
		
		;ConsoleWrite(Chr(13) & Chr(10))
	EndIf
EndFunc   ;==>_Authenticate

Func _User($CookieData)
	If $CookieData <> '' Then
		$Decrypted = _Base64Decode($CookieData);_StringEncrypt(0, $CookieData, 'DLS19')
		$CCC = _StringBetween($Decrypted, '::[', ']::')
		$XXX = StringSplit($Decrypted, '::[')
		$DDD = IniRead($_DOCUMENT_ROOT & '\dirlist\.htduser', $XXX[1], 'Password', -1)
		If $CCC[0] = $DDD Then
			Return $XXX[1]
		Else
			Return $AnonymousName
		EndIf
	Else
	;ConsoleWrite(Chr(13) & Chr(10))
;echo($CookieData)
;echo(_Base64Decode($CookieData))
		Return $AnonymousName
	EndIf
	
EndFunc   ;==>_User

Func _Main()
	ConsoleWrite('Content-Type: text/html' & Chr(13) & Chr(10))
EndFunc   ;==>_Main

Func _Transfer($TransPath)
	Local $HTML
$HTML &= '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">' & @CRLF
$HTML &= '<html xml:lang="en" lang="en" xmlns="http://www.w3.org/1999/xhtml">' & @CRLF
$HTML &= '<head>' & @CRLF
$HTML &= '<meta http-equiv="content-type" content="text/html; charset=iso-8859-1" />' & @CRLF
$HTML &= '<title>Please stand by...</title>' & @CRLF
$HTML &= '<meta http-equiv="refresh" content="3; url=' & $_SCRIPT_NAME & '?' & $DIRQuery & '=' & $TransPath & '" />' & @CRLF
;$HTML &= '<style type="text/css" media="all">'
;$HTML &= '@import url(/dirlist/css/default.css);'
;$HTML &= '</style>'
$HTML &= '<link href="/dirlist/css/default.css" rel="stylesheet" type="text/css">' & @CRLF
$HTML &= '</head>' & @CRLF
$HTML &= '<body>' & @CRLF
$HTML &= '<div id="redirectwrap">' & @CRLF
$HTML &= '<h4>Thanks</h4>' & @CRLF
$HTML &= '<p>Processing your requests. <br /><br />Please wait while we transfer you...</p>' & @CRLF
$HTML &= '<p class="redirectfoot">(<a href="' & $_SCRIPT_NAME & '?' & $DIRQuery & '=' & $TransPath & '">Or click here if you do not wish to wait</a>)</p>'
$HTML &= '</div>'
$HTML &= '</body>'
$HTML &= '</html>'
echo ($HTML)

EndFunc

Func _Logout()
			$Cookie = 'uid='
			ConsoleWrite('Set-Cookie: ' & $Cookie & Chr(13) & Chr(10))
			ConsoleWrite(Chr(13) & Chr(10))
			$DIR = _Get_DIR($DIRQuery)
			ConsoleWrite('<meta http-equiv="refresh" content="0; url=' & $_SCRIPT_NAME & '?' & $DIRQuery & '=' & $DIR & '" />')
			;_Transfer("/")
			
	EndFunc

$Log = _Post ($LoginUserPost)
$Ps = _Post ($LoginPasswordPost)
_Main()
_Authenticate($Log, $Ps)


;echo ($_POST_raw)
;If Not $LoggedUser = $AnonymousName Then

	
$DIR = _Get_DIR($DIRQuery)
$DIR = StringReplace($DIR, '\', '/')

If StringRight($DIR, 1) = '/' Then
	$DIR = StringTrimRight($DIR, 1)
EndIf

If StringInStr($DIR, '/..') > 0 Then
	$DIR = StringReplace($DIR, '/..', '')
EndIf

If StringLeft($DIR, 2) = '..' Then
	$DIR = StringTrimLeft($DIR, 2)
EndIf

If StringLeft($DIR, 1) = '/' Then
	_Input($DIR)
Else
	$DIR = _StringInsert($DIR, '/', 0)
	If StringLen($_POST_raw) > 1 Then
	;If Not $LoggedUser = $AnonymousName Then
	_Transfer(_Get_DIR($TransferQuery))
	;Else
	;_Input($DIR)
	;EndIf

Else
		_Input($DIR)
	EndIf

EndIf
